var __create = Object.create;
var __defProp = Object.defineProperty;
var __defProps = Object.defineProperties;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropDescs = Object.getOwnPropertyDescriptors;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getOwnPropSymbols = Object.getOwnPropertySymbols;
var __getProtoOf = Object.getPrototypeOf;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __propIsEnum = Object.prototype.propertyIsEnumerable;
var __defNormalProp = (obj, key, value) => key in obj ? __defProp(obj, key, { enumerable: true, configurable: true, writable: true, value }) : obj[key] = value;
var __spreadValues = (a, b) => {
  for (var prop in b || (b = {}))
    if (__hasOwnProp.call(b, prop))
      __defNormalProp(a, prop, b[prop]);
  if (__getOwnPropSymbols)
    for (var prop of __getOwnPropSymbols(b)) {
      if (__propIsEnum.call(b, prop))
        __defNormalProp(a, prop, b[prop]);
    }
  return a;
};
var __spreadProps = (a, b) => __defProps(a, __getOwnPropDescs(b));
var __objRest = (source, exclude) => {
  var target = {};
  for (var prop in source)
    if (__hasOwnProp.call(source, prop) && exclude.indexOf(prop) < 0)
      target[prop] = source[prop];
  if (source != null && __getOwnPropSymbols)
    for (var prop of __getOwnPropSymbols(source)) {
      if (exclude.indexOf(prop) < 0 && __propIsEnum.call(source, prop))
        target[prop] = source[prop];
    }
  return target;
};
var __esm = (fn, res) => function __init() {
  return fn && (res = (0, fn[__getOwnPropNames(fn)[0]])(fn = 0)), res;
};
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toESM = (mod, isNodeMode, target) => (target = mod != null ? __create(__getProtoOf(mod)) : {}, __copyProps(isNodeMode || !mod || !mod.__esModule ? __defProp(target, "default", { value: mod, enumerable: true }) : target, mod));
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);

// src/middleware/force-https.ts
var force_https_default;
var init_force_https = __esm({
  "src/middleware/force-https.ts"() {
    force_https_default = (req, res, next) => {
      if (req.headers["x-forwarded-proto"] && req.headers["x-forwarded-proto"] !== "https") {
        res.redirect(`https://${req.hostname}${req.originalUrl}`);
      } else {
        next();
      }
    };
  }
});

// src/middleware/index.ts
var middleware_exports = {};
__export(middleware_exports, {
  asyncWrapMiddleware: () => import_async_express_mw.default,
  cookieParserMiddleware: () => import_cookie_parser.default,
  forceHttpsMiddleware: () => force_https_default,
  staticMiddleware: () => import_express2.static
});
var import_cookie_parser, import_async_express_mw, import_express2;
var init_middleware = __esm({
  "src/middleware/index.ts"() {
    import_cookie_parser = __toESM(require("cookie-parser"));
    import_async_express_mw = __toESM(require("async-express-mw"));
    import_express2 = require("express");
    init_force_https();
  }
});

// src/index.ts
var src_exports = {};
__export(src_exports, {
  ClassErrorMiddleware: () => ClassErrorMiddleware,
  ClassMiddleware: () => ClassMiddleware,
  Controller: () => Controller,
  Delete: () => import_hypernight4.Delete,
  ErrorMiddleware: () => ErrorMiddleware,
  Get: () => import_hypernight4.Get,
  HttpResponse: () => HttpResponse,
  HttpResponseBadRequest: () => HttpResponseBadRequest,
  HttpResponseClientError: () => HttpResponseClientError,
  HttpResponseConflict: () => HttpResponseConflict,
  HttpResponseCreated: () => HttpResponseCreated,
  HttpResponseForbidden: () => HttpResponseForbidden,
  HttpResponseInternalServerError: () => HttpResponseInternalServerError,
  HttpResponseMethodNotAllowed: () => HttpResponseMethodNotAllowed,
  HttpResponseMovedPermanently: () => HttpResponseMovedPermanently,
  HttpResponseNoContent: () => HttpResponseNoContent,
  HttpResponseNotFound: () => HttpResponseNotFound,
  HttpResponseNotImplemented: () => HttpResponseNotImplemented,
  HttpResponseOK: () => HttpResponseOK,
  HttpResponseRedirect: () => HttpResponseRedirect,
  HttpResponseRedirection: () => HttpResponseRedirection,
  HttpResponseServerError: () => HttpResponseServerError,
  HttpResponseSuccess: () => HttpResponseSuccess,
  HttpResponseTooManyRequests: () => HttpResponseTooManyRequests,
  HttpResponseUnauthorized: () => HttpResponseUnauthorized,
  Middleware: () => Middleware2,
  NextFunction: () => import_express.NextFunction,
  ParseBody: () => ParseBody,
  Patch: () => import_hypernight4.Patch,
  Post: () => import_hypernight4.Post,
  Put: () => import_hypernight4.Put,
  Response: () => import_express.Response,
  ValidateBody: () => ValidateBody,
  ValidationError: () => ValidationError,
  asOpenAPIPath: () => asOpenAPIPath,
  asOpenAPIPathParams: () => asOpenAPIPathParams,
  authWithJWT: () => authWithJWT,
  createServer: () => createServer,
  err: () => err,
  getRouteMap: () => getRouteMap,
  getRouteSnippets: () => getRouteSnippets,
  isHttpResponse: () => isHttpResponse,
  isHttpResponseBadRequest: () => isHttpResponseBadRequest,
  isHttpResponseClientError: () => isHttpResponseClientError,
  isHttpResponseConflict: () => isHttpResponseConflict,
  isHttpResponseCreated: () => isHttpResponseCreated,
  isHttpResponseForbidden: () => isHttpResponseForbidden,
  isHttpResponseInternalServerError: () => isHttpResponseInternalServerError,
  isHttpResponseMethodNotAllowed: () => isHttpResponseMethodNotAllowed,
  isHttpResponseMovedPermanently: () => isHttpResponseMovedPermanently,
  isHttpResponseNoContent: () => isHttpResponseNoContent,
  isHttpResponseNotFound: () => isHttpResponseNotFound,
  isHttpResponseNotImplemented: () => isHttpResponseNotImplemented,
  isHttpResponseOK: () => isHttpResponseOK,
  isHttpResponseRedirect: () => isHttpResponseRedirect,
  isHttpResponseRedirection: () => isHttpResponseRedirection,
  isHttpResponseServerError: () => isHttpResponseServerError,
  isHttpResponseSuccess: () => isHttpResponseSuccess,
  isHttpResponseTooManyRequests: () => isHttpResponseTooManyRequests,
  isHttpResponseUnauthorized: () => isHttpResponseUnauthorized,
  listRoutes: () => list_routes_default,
  listen: () => listen_default,
  load: () => load_default,
  notfound: () => notfound,
  ok: () => ok,
  permits: () => permits,
  printRoutes: () => print_routes_default,
  requires: () => requires,
  routemapToOpenAPI: () => routemapToOpenAPI,
  unauthorized: () => unauthorized
});
module.exports = __toCommonJS(src_exports);

// src/http/responses.ts
var HttpResponse = class {
  constructor(body, options = {}) {
    this.body = body;
    this.isHttpResponse = true;
    this.stream = false;
    this.headers = {};
    this.stream = options.stream || false;
  }
  setHeader(name, value) {
    this.headers[name] = value;
    return this;
  }
  getHeader(name) {
    return this.headers[name];
  }
  getHeaders() {
    return __spreadValues({}, this.headers);
  }
};
function isHttpResponse(obj) {
  return obj instanceof HttpResponse || typeof obj === "object" && obj !== null && obj.isHttpResponse === true;
}
var HttpResponseSuccess = class extends HttpResponse {
  constructor(body, options = {}) {
    super(body, options);
    this.isHttpResponseSuccess = true;
  }
};
function isHttpResponseSuccess(obj) {
  return obj instanceof HttpResponseSuccess || typeof obj === "object" && obj !== null && obj.isHttpResponseSuccess === true;
}
var HttpResponseOK = class extends HttpResponseSuccess {
  constructor(body, options = {}) {
    super(body, options);
    this.isHttpResponseOK = true;
    this.statusCode = 200;
    this.statusMessage = "OK";
  }
};
function isHttpResponseOK(obj) {
  return obj instanceof HttpResponseOK || typeof obj === "object" && obj !== null && obj.isHttpResponseOK === true;
}
var HttpResponseCreated = class extends HttpResponseSuccess {
  constructor(body, options = {}) {
    super(body, options);
    this.isHttpResponseCreated = true;
    this.statusCode = 201;
    this.statusMessage = "CREATED";
  }
};
function isHttpResponseCreated(obj) {
  return obj instanceof HttpResponseCreated || typeof obj === "object" && obj !== null && obj.isHttpResponseCreated === true;
}
var HttpResponseNoContent = class extends HttpResponseSuccess {
  constructor() {
    super();
    this.isHttpResponseNoContent = true;
    this.statusCode = 204;
    this.statusMessage = "NO CONTENT";
  }
};
function isHttpResponseNoContent(obj) {
  return obj instanceof HttpResponseNoContent || typeof obj === "object" && obj !== null && obj.isHttpResponseNoContent === true;
}
var HttpResponseRedirection = class extends HttpResponse {
  constructor(body, options = {}) {
    super(body, options);
    this.isHttpResponseRedirection = true;
  }
};
function isHttpResponseRedirection(obj) {
  return obj instanceof HttpResponseRedirection || typeof obj === "object" && obj !== null && obj.isHttpResponseRedirection === true;
}
var HttpResponseMovedPermanently = class extends HttpResponseRedirection {
  constructor(path4) {
    super();
    this.path = path4;
    this.isHttpResponseMovedPermanently = true;
    this.statusCode = 301;
    this.statusMessage = "MOVED PERMANENTLY";
  }
};
function isHttpResponseMovedPermanently(obj) {
  return obj instanceof HttpResponseMovedPermanently || typeof obj === "object" && obj !== null && obj.isHttpResponseMovedPermanently === true;
}
var HttpResponseRedirect = class extends HttpResponseRedirection {
  constructor(path4, body, options = {}) {
    super(body, options);
    this.path = path4;
    this.isHttpResponseRedirect = true;
    this.statusCode = 302;
    this.statusMessage = "FOUND";
  }
};
function isHttpResponseRedirect(obj) {
  return obj instanceof HttpResponseRedirect || typeof obj === "object" && obj !== null && obj.isHttpResponseRedirect === true;
}
var HttpResponseClientError = class extends HttpResponse {
  constructor(body, options = {}) {
    super(body, options);
    this.isHttpResponseClientError = true;
  }
};
function isHttpResponseClientError(obj) {
  return obj instanceof HttpResponseClientError || typeof obj === "object" && obj !== null && obj.isHttpResponseClientError === true;
}
var HttpResponseBadRequest = class extends HttpResponseClientError {
  constructor(body, options = {}) {
    super(body, options);
    this.isHttpResponseBadRequest = true;
    this.statusCode = 400;
    this.statusMessage = "BAD REQUEST";
  }
};
function isHttpResponseBadRequest(obj) {
  return obj instanceof HttpResponseBadRequest || typeof obj === "object" && obj !== null && obj.isHttpResponseBadRequest === true;
}
var HttpResponseUnauthorized = class extends HttpResponseClientError {
  constructor(body, options = {}) {
    super(body, options);
    this.isHttpResponseUnauthorized = true;
    this.statusCode = 401;
    this.statusMessage = "UNAUTHORIZED";
    this.setHeader("WWW-Authenticate", "");
  }
};
function isHttpResponseUnauthorized(obj) {
  return obj instanceof HttpResponseUnauthorized || typeof obj === "object" && obj !== null && obj.isHttpResponseUnauthorized === true;
}
var HttpResponseForbidden = class extends HttpResponseClientError {
  constructor(body, options = {}) {
    super(body, options);
    this.isHttpResponseForbidden = true;
    this.statusCode = 403;
    this.statusMessage = "FORBIDDEN";
  }
};
function isHttpResponseForbidden(obj) {
  return obj instanceof HttpResponseForbidden || typeof obj === "object" && obj !== null && obj.isHttpResponseForbidden === true;
}
var HttpResponseNotFound = class extends HttpResponseClientError {
  constructor(body, options = {}) {
    super(body, options);
    this.isHttpResponseNotFound = true;
    this.statusCode = 404;
    this.statusMessage = "NOT FOUND";
  }
};
function isHttpResponseNotFound(obj) {
  return obj instanceof HttpResponseNotFound || typeof obj === "object" && obj !== null && obj.isHttpResponseNotFound === true;
}
var HttpResponseMethodNotAllowed = class extends HttpResponseClientError {
  constructor(body, options = {}) {
    super(body, options);
    this.isHttpResponseMethodNotAllowed = true;
    this.statusCode = 405;
    this.statusMessage = "METHOD NOT ALLOWED";
  }
};
function isHttpResponseMethodNotAllowed(obj) {
  return obj instanceof HttpResponseMethodNotAllowed || typeof obj === "object" && obj !== null && obj.isHttpResponseMethodNotAllowed === true;
}
var HttpResponseConflict = class extends HttpResponseClientError {
  constructor(body, options = {}) {
    super(body, options);
    this.isHttpResponseConflict = true;
    this.statusCode = 409;
    this.statusMessage = "CONFLICT";
  }
};
function isHttpResponseConflict(obj) {
  return obj instanceof HttpResponseConflict || typeof obj === "object" && obj !== null && obj.isHttpResponseConflict === true;
}
var HttpResponseTooManyRequests = class extends HttpResponseClientError {
  constructor(body, options = {}) {
    super(body, options);
    this.isHttpResponseTooManyRequests = true;
    this.statusCode = 429;
    this.statusMessage = "TOO MANY REQUESTS";
  }
};
function isHttpResponseTooManyRequests(obj) {
  return obj instanceof HttpResponseTooManyRequests || typeof obj === "object" && obj !== null && obj.isHttpResponseTooManyRequests === true;
}
var HttpResponseServerError = class extends HttpResponse {
  constructor(body, options = {}) {
    super(body, options);
    this.isHttpResponseServerError = true;
  }
};
function isHttpResponseServerError(obj) {
  return obj instanceof HttpResponseServerError || typeof obj === "object" && obj !== null && obj.isHttpResponseServerError === true;
}
var HttpResponseInternalServerError = class extends HttpResponseServerError {
  constructor(body, options = {}) {
    super(body, options);
    this.isHttpResponseInternalServerError = true;
    this.statusCode = 500;
    this.statusMessage = "INTERNAL SERVER ERROR";
  }
};
function isHttpResponseInternalServerError(obj) {
  return obj instanceof HttpResponseInternalServerError || typeof obj === "object" && obj !== null && obj.isHttpResponseInternalServerError === true;
}
var HttpResponseNotImplemented = class extends HttpResponseServerError {
  constructor(body, options = {}) {
    super(body, options);
    this.isHttpResponseNotImplemented = true;
    this.statusCode = 501;
    this.statusMessage = "NOT IMPLEMENTED";
  }
};
function isHttpResponseNotImplemented(obj) {
  return obj instanceof HttpResponseNotImplemented || typeof obj === "object" && obj !== null && obj.isHttpResponseNotImplemented === true;
}

// src/validation.ts
var import_ajv = __toESM(require("ajv"));
var import_lodash = __toESM(require("lodash"));
var import_hypernight = require("@hyperstackjs/hypernight");

// src/errors.ts
var ValidationError = class extends Error {
  constructor(errors) {
    super();
    this.errors = errors;
    this.isValidationError = true;
    Object.setPrototypeOf(this, ValidationError.prototype);
  }
};

// src/validation.ts
var permits = (schema) => schema.parse.bind(schema);
var requires = (schema) => {
  const s = schema.strict();
  return (d) => {
    const result = s.safeParse(d);
    if (!result.success) {
      throw new ValidationError(result.error.issues);
    }
    return result.data;
  };
};
function ParseBody(schema) {
  function parseBody(req, res, next) {
    const { success, data, error } = schema.safeParse(req.body);
    if (!success) {
      throw new ValidationError(error.issues);
    } else {
      req.body = data;
    }
    next();
  }
  parseBody.params = { schema: { zod: schema } };
  return (0, import_hypernight.Middleware)(parseBody);
}
function ValidateBody(schema, customValidations = {}) {
  const ajv = new import_ajv.default();
  import_lodash.default.toPairs(customValidations).forEach(([validationName, validationSchema]) => {
    ajv.addKeyword(validationName, validationSchema);
  });
  function validateBody(req, res, next) {
    const validator = ajv.compile(schema);
    if (!validator(req.body)) {
      throw new ValidationError(validator.errors);
    }
    next();
  }
  return (0, import_hypernight.Middleware)(validateBody);
}

// src/types.ts
var import_express = require("express");

// src/api.ts
var import_hypernight3 = require("@hyperstackjs/hypernight");
var import_async_express_mw2 = __toESM(require("async-express-mw"));
var import_lodash2 = __toESM(require("lodash"));

// src/http/response-sender.ts
var responseSender = (response, result) => {
  response.status(result.statusCode);
  response.set(result.getHeaders());
  if (typeof result.body === "number") {
    result.body = result.body.toString();
  }
  response.send(result.body);
};
var response_sender_default = responseSender;

// src/http/response-handler.ts
var responseHandler = (fn) => function asyncUtilWrap(request, response, next) {
  const fnReturn = fn(request, response, next);
  Promise.resolve(fnReturn).then((result) => {
    if (result instanceof HttpResponse) {
      response_sender_default(response, result);
    } else {
      response_sender_default(response, new HttpResponseOK(result));
    }
  }).catch(next);
};
var response_handler_default = responseHandler;

// src/server/hyperserver.ts
var import_helmet = __toESM(require("helmet"));
var import_compression = __toESM(require("compression"));
var import_hypernight2 = require("@hyperstackjs/hypernight");
var import_body_parser = require("body-parser");
var import_express_pino_logger = __toESM(require("express-pino-logger"));
var import_pino = __toESM(require("pino"));
var import_debug2 = __toESM(require("debug"));

// src/server/index-sender.ts
var import_path = __toESM(require("path"));
var import_fs = __toESM(require("fs"));
var indexSender = (indexFolder) => {
  const indexFile = import_path.default.resolve(indexFolder, "index.html");
  if (!import_fs.default.existsSync(indexFile)) {
    throw new Error(`controllers: index file redirect is on, but no such file: ${indexFile}`);
  }
  return (_req, res) => {
    res.sendFile(indexFile);
  };
};
var index_sender_default = indexSender;

// src/server/not-found.ts
var notFound = (req, res) => {
  response_sender_default(res, new HttpResponseNotFound());
};
var not_found_default = notFound;

// src/server/set-request-id.ts
var import_uuid = require("uuid");
var resolveId = (req, opts) => {
  switch (opts.mode) {
    case "generate": {
      return (0, import_uuid.v4)();
    }
    case "passthrough": {
      return req.id || req.get("x-request-id");
    }
    case "passthrough-or-generate": {
      return req.id || req.get("x-request-id") || (0, import_uuid.v4)();
    }
    case "none": {
      return null;
    }
  }
};
var setRequestId = (opts) => (req, res, next) => {
  req.id = resolveId(req, opts);
  if (req.id) {
    res.set("x-request-id", req.id);
  }
  next();
};
var set_request_id_default = setRequestId;

// src/server/error-handler.ts
var import_debug = __toESM(require("debug"));
var debug = (0, import_debug.default)("hypercontroller:error-handler");
var errorHandler = ({
  logger,
  sendValidationErrors = false
}) => async (err2, req, res, next) => {
  debug("error %o", err2);
  debug("sending validation errors out? %o", sendValidationErrors);
  if (err2 instanceof HttpResponse) {
    response_sender_default(res, err2);
  } else if (err2.isValidationError && sendValidationErrors) {
    response_sender_default(res, new HttpResponseBadRequest({
      error: "validation",
      validationErrors: err2.errors
    }));
  } else if (err2.isModelError) {
    response_sender_default(res, new HttpResponseBadRequest({ error: err2.message }));
  } else if (err2) {
    const resolvedLogger = req && req.logger ? req.logger : logger;
    if (resolvedLogger) {
      resolvedLogger.error({ err: err2 }, `Internal error`);
    }
    response_sender_default(res, new HttpResponseBadRequest({ error: "bad request" }));
  } else {
    next();
  }
};
var error_handler_default = errorHandler;

// src/server/hyperserver.ts
var debug2 = (0, import_debug2.default)("hyperserver");
var getOrCreateLogger = (opts) => {
  if (opts === false) {
    return null;
  }
  if (opts && opts !== true) {
    return opts;
  }
  debug2("creating logger");
  return (0, import_pino.default)();
};
var getOrCreateMiddleware = (logger, opts) => {
  if (opts === false) {
    return null;
  }
  if (opts && opts !== true) {
    return opts;
  }
  debug2("creating own logger middleware");
  return (0, import_express_pino_logger.default)({ logger });
};
var defaults = {
  helmet: void 0,
  json: { limit: "5mb" },
  urlencoded: { limit: "5mb", extended: true },
  requestIdOpts: { mode: "passthrough-or-generate" }
};
var isDefaultSetting = (s) => s === true || s === void 0;
var HyperServer = class extends import_hypernight2.Server {
  constructor(controllers, opts) {
    const {
      cookieParserMiddleware: cookieParserMiddleware2,
      forceHttpsMiddleware,
      staticMiddleware: staticMiddleware2
    } = (init_middleware(), __toCommonJS(middleware_exports));
    super(process.env.NODE_ENV === "development");
    const {
      staticFolder,
      indexCatchAll,
      forceHttps,
      gzip,
      cookieSecret,
      logging,
      helmet: helmetOpts,
      json: jsonOpts,
      urlencoded: urlencodedOpts,
      requestId: requestIdOpts,
      sendValidationErrors,
      beforeControllers,
      afterControllers,
      beforeMiddleware,
      afterMiddleware
    } = opts;
    const logger = getOrCreateLogger(logging && logging.logger);
    const middleware = getOrCreateMiddleware(logger, logging && logging.middleware);
    if (beforeMiddleware) {
      beforeMiddleware(this.app);
    }
    if (requestIdOpts !== false) {
      const res = isDefaultSetting(requestIdOpts) ? defaults.requestIdOpts : requestIdOpts;
      this.app.use(set_request_id_default(res));
    }
    if (middleware) {
      this.app.use(middleware);
      this.app.use((req, res, next) => {
        ;
        req.logger = req.log || logger;
        if (next) {
          next();
        }
      });
    }
    if (forceHttps) {
      this.app.use(forceHttpsMiddleware);
    }
    if (gzip !== false) {
      const res = isDefaultSetting(gzip) ? void 0 : gzip;
      debug2("gzip: %o", res);
      this.app.use((0, import_compression.default)(res));
    }
    if (helmetOpts !== false) {
      const res = isDefaultSetting(helmetOpts) ? defaults.helmet : helmetOpts;
      debug2("helmet: %o", res);
      this.app.use((0, import_helmet.default)(res));
    }
    if (jsonOpts !== false) {
      const res = isDefaultSetting(jsonOpts) ? defaults.json : jsonOpts;
      debug2("json: %o", res);
      this.app.use((0, import_body_parser.json)(res));
    }
    if (urlencodedOpts !== false) {
      const res = isDefaultSetting(urlencodedOpts) ? defaults.urlencoded : urlencodedOpts;
      debug2("urlencoded: %o", res);
      this.app.use((0, import_body_parser.urlencoded)(res));
    }
    if (cookieSecret) {
      this.app.use(cookieParserMiddleware2(cookieSecret));
    }
    if (staticFolder) {
      this.app.use(staticMiddleware2(staticFolder));
    }
    if (beforeControllers) {
      beforeControllers(this.app);
    }
    super.addControllers(controllers);
    if (afterControllers) {
      afterControllers(this.app);
    }
    if (staticFolder && indexCatchAll) {
      this.app.get("*", index_sender_default(staticFolder));
    }
    this.app.use(not_found_default);
    this.app.use(error_handler_default({ logger, sendValidationErrors: !!sendValidationErrors }));
    if (afterMiddleware) {
      afterMiddleware(this.app);
    }
    ;
    this.app.__opts = opts;
  }
};
var createServer = ({
  controllers,
  opts = {}
}) => {
  const server = new HyperServer(controllers.map((K) => new K()), opts);
  return server.app;
};

// src/server/list-routes.ts
var import_path2 = __toESM(require("path"));
function getPathFromRegex(regexp) {
  return regexp.toString().replace("/^", "").replace("?(?=\\/|$)/i", "").replace(/\\\//g, "/");
}
function combineStacks(acc, stack) {
  if (stack.handle.stack) {
    const routerPath = getPathFromRegex(stack.regexp);
    return [
      ...acc,
      ...stack.handle.stack.map((stack2) => __spreadValues({ routerPath }, stack2))
    ];
  }
  return [...acc, stack];
}
function getStacks(app) {
  if (app.routes) {
    return Object.keys(app.routes).reduce((acc, method) => [...acc, ...app.routes[method]], []).map((route) => ({ route: { stack: [route] } }));
  }
  if (app._router && app._router.stack) {
    return app._router.stack.reduce(combineStacks, []);
  }
  if (app.stack) {
    return app.stack.reduce(combineStacks, []);
  }
  if (app.router && app.router.stack) {
    return app.router.stack.reduce(combineStacks, []);
  }
  return [];
}
function listRoutes(app) {
  const stacks = getStacks(app);
  const routes = [];
  if (stacks) {
    for (const stack of stacks) {
      if (stack.route) {
        const routeLogged = {};
        for (const route of stack.route.stack) {
          const method = route.method ? route.method.toUpperCase() : null;
          if (!routeLogged[method] && method) {
            const stackPath = stack.routerPath || route.path ? import_path2.default.resolve([stack.routerPath, stack.route.path, route.path].filter((s) => !!s).join("")) : stack.route.path;
            routes.push({ verb: method, path: stackPath });
            routeLogged[method] = true;
          }
        }
      }
    }
  }
  return routes;
}
var list_routes_default = listRoutes;

// src/server/print-routes.ts
var import_colorette = require("colorette");
var spacer = (verb, space = 8) => {
  const delta = space - verb.length;
  return verb + " ".repeat(delta);
};
var verbcolor = (verb) => {
  if (verb.startsWith("GET")) {
    return (0, import_colorette.green)(verb);
  } else if (verb.startsWith("DELETE")) {
    return (0, import_colorette.red)(verb);
  } else {
    return (0, import_colorette.yellow)(verb);
  }
};
var printRoutes = (app, log = console.log) => {
  const routes = list_routes_default(app);
  for (const route of routes) {
    log(`${verbcolor(spacer(route.verb))} ${route.path}`);
  }
};
var print_routes_default = printRoutes;

// src/server/load.ts
var import_path3 = __toESM(require("path"));
var import_glob = __toESM(require("glob"));
var load = (patt, cwd = process.cwd()) => import_glob.default.sync(import_path3.default.join(cwd, patt)).map((f) => {
  let mod = null;
  try {
    mod = require(f);
  } catch (e) {
    console.log(`error dynamically loading '${f}'
${e.toString()}`);
    throw e;
  }
  return mod.default || mod;
});
var load_default = load;

// src/server/listen.ts
var banner = (port) => `listening on port: ${port}`;
var listen = (app, opts = {}) => {
  const { port, bannerfn, log } = opts;
  const logfn = log || console.log;
  const resolvedPort = port || process.env.PORT || 5150;
  logfn((bannerfn || banner)(resolvedPort));
  app.listen(resolvedPort);
};
var listen_default = listen;

// src/api.ts
var import_hypernight4 = require("@hyperstackjs/hypernight");
var ok = (data) => new HttpResponseOK(data);
var unauthorized = (error) => new HttpResponseUnauthorized({
  error
});
var err = (error) => new HttpResponseBadRequest({
  error
});
var notfound = (error) => new HttpResponseNotFound({
  error
});
var Middleware2 = (mware) => (0, import_hypernight3.Middleware)(import_lodash2.default.castArray(mware).map((m) => (0, import_async_express_mw2.default)(m)));
var ClassMiddleware = (mware) => (0, import_hypernight3.ClassMiddleware)(import_lodash2.default.castArray(mware).map((m) => (0, import_async_express_mw2.default)(m)));
var ErrorMiddleware = (mware) => (0, import_hypernight3.ErrorMiddleware)(import_lodash2.default.castArray(mware).map((m) => (0, import_async_express_mw2.default)(m)));
var ClassErrorMiddleware = (mware) => (0, import_hypernight3.ClassErrorMiddleware)(import_lodash2.default.castArray(mware).map((m) => (0, import_async_express_mw2.default)(m)));
var Controller = (path4) => (target) => {
  const k = (0, import_hypernight3.Controller)(path4)(target);
  (0, import_hypernight3.ClassWrapper)(response_handler_default)(target);
  return k;
};

// src/jwt.ts
var import_permit = require("permit");
var import_jsonwebtoken = require("jsonwebtoken");
var forceHS512 = (jwtOptions) => jwtOptions ? __spreadProps(__spreadValues({}, jwtOptions), { algorithm: "HS512" }) : { algorithm: "HS512" };
var forceHS512Verify = (jwtOptions) => jwtOptions ? __spreadProps(__spreadValues({}, jwtOptions), { algorithms: ["HS512"] }) : { algorithms: ["HS512"] };
var createAuth = (verify2, { loader, bearer }) => {
  const permit = new import_permit.Bearer(bearer || {
    query: "access_token"
  });
  return async (req) => {
    const token = permit.check(req);
    if (!token) {
      throw new HttpResponseUnauthorized("no token");
    }
    let payload;
    try {
      payload = await verify2(token);
    } catch (error) {
      throw new HttpResponseUnauthorized("bad token");
    }
    const detail = await loader(payload);
    if (!detail || !detail.user) {
      throw new HttpResponseUnauthorized("no such user");
    }
    return detail;
  };
};
var buildAuth = (verify2, MWare, opts) => {
  const auth = createAuth(verify2, opts);
  return MWare(async (req, res, next) => {
    const _a = await auth(req), { user } = _a, rest = __objRest(_a, ["user"]);
    req.user = user;
    req.state = rest;
    next();
  });
};
var authWithJWT = ({
  secret,
  jwtOptions,
  loader,
  bearer
}) => {
  if (!secret) {
    throw new Error("no JWT secret set");
  }
  const resolvedOptions = jwtOptions || {
    expiresIn: "14d"
  };
  const signJWT = (payload) => (0, import_jsonwebtoken.sign)(payload, secret, forceHS512(resolvedOptions));
  const verifyJWT = (token) => new Promise((resolve, reject) => {
    (0, import_jsonwebtoken.verify)(token, secret, forceHS512Verify(resolvedOptions), (err2, value) => {
      if (err2) {
        reject(err2);
      } else {
        resolve(value);
      }
    });
  });
  return {
    MustAuthWithJWT: buildAuth(verifyJWT, ClassMiddleware, { loader, bearer }),
    MustAuthRouteWithJWT: buildAuth(verifyJWT, Middleware2, { loader, bearer }),
    signJWT,
    verifyJWT
  };
};

// src/routes.ts
var import_lodash3 = __toESM(require("lodash"));
var import_openapi3_ts = require("openapi3-ts");
var import_openapi_snippet = __toESM(require("openapi-snippet"));
var import_path_to_regexp = require("path-to-regexp");
var import_zod_openapi = require("@anatine/zod-openapi");
var import_reflect_metadata = require("reflect-metadata");
var getRouteMap = (controllers) => {
  const routemap = controllers.map((Cnt) => {
    const classKey = Reflect.getOwnMetadataKeys(Cnt.prototype).find((k) => k.toString().match(/Class Metadata/));
    const path4 = classKey ? Reflect.getOwnMetadata(classKey, Cnt.prototype).basePath : "";
    return {
      [Cnt.name]: {
        path: path4,
        actions: Object.getOwnPropertyNames(Cnt.prototype).filter((p) => p !== "constructor").map((p) => ({
          meta: Reflect.getOwnMetadata(p, Cnt.prototype),
          action: p
        })).filter((desc) => desc.meta).map(({ meta, action }) => {
          var _a;
          return {
            action,
            schema: (_a = meta == null ? void 0 : meta.middlewares) == null ? void 0 : _a.map((m) => {
              var _a2;
              return (_a2 = m.params) == null ? void 0 : _a2.schema;
            }).find((s) => s),
            routes: meta.httpRoutes.map((r) => ({
              parsedPath: (0, import_path_to_regexp.parse)(path4 + r.path),
              verb: r.httpDecorator,
              path: r.path
            }))
          };
        })
      }
    };
  }).reduce((acc, m) => __spreadValues(__spreadValues({}, acc), m), {});
  return routemap;
};
var asOpenAPIPath = (parsedPath) => {
  return parsedPath.map((part) => import_lodash3.default.isString(part) ? part : `/{${part.name}}`).join("");
};
var asOpenAPIPathParams = (parsedPath) => {
  return parsedPath.filter((part) => !import_lodash3.default.isString(part)).map(({ name }) => ({
    name,
    schema: { type: "string" },
    required: true,
    in: "path"
  }));
};
var routemapToOpenAPI = (routemap, url = "http://localhost:5150") => {
  const builder = import_openapi3_ts.OpenApiBuilder.create({
    openapi: "3.0.0",
    servers: [{ url }],
    info: {
      title: "",
      version: ""
    },
    paths: {}
  });
  import_lodash3.default.forEach(routemap, (controller, _name) => {
    controller.actions.forEach((action) => {
      action.routes.forEach((route) => {
        var _a;
        const path4 = asOpenAPIPath(route.parsedPath);
        const pathmap = builder.rootDoc.paths[path4] || {};
        builder.addPath(path4, __spreadValues(__spreadValues({}, pathmap), {
          [route.verb.toString()]: __spreadProps(__spreadValues({
            responses: {
              "200": {
                description: "OK"
              }
            }
          }, ((_a = action.schema) == null ? void 0 : _a.zod) && {
            requestBody: {
              required: true,
              content: {
                "application/json": {
                  schema: (0, import_zod_openapi.generateSchema)(action.schema.zod)
                }
              }
            }
          }), {
            parameters: asOpenAPIPathParams(route.parsedPath)
          })
        }));
      });
    });
  });
  return builder;
};
var getRouteSnippets = (routemap, verb, path4, snippets = ["shell_curl"], url = "http://localhost:5150") => {
  const api = routemapToOpenAPI(routemap, url);
  const results = import_openapi_snippet.default.getEndpointSnippets(api.rootDoc, path4, verb, snippets, {
    short: true
  });
  return results;
};
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {
  ClassErrorMiddleware,
  ClassMiddleware,
  Controller,
  Delete,
  ErrorMiddleware,
  Get,
  HttpResponse,
  HttpResponseBadRequest,
  HttpResponseClientError,
  HttpResponseConflict,
  HttpResponseCreated,
  HttpResponseForbidden,
  HttpResponseInternalServerError,
  HttpResponseMethodNotAllowed,
  HttpResponseMovedPermanently,
  HttpResponseNoContent,
  HttpResponseNotFound,
  HttpResponseNotImplemented,
  HttpResponseOK,
  HttpResponseRedirect,
  HttpResponseRedirection,
  HttpResponseServerError,
  HttpResponseSuccess,
  HttpResponseTooManyRequests,
  HttpResponseUnauthorized,
  Middleware,
  NextFunction,
  ParseBody,
  Patch,
  Post,
  Put,
  Response,
  ValidateBody,
  ValidationError,
  asOpenAPIPath,
  asOpenAPIPathParams,
  authWithJWT,
  createServer,
  err,
  getRouteMap,
  getRouteSnippets,
  isHttpResponse,
  isHttpResponseBadRequest,
  isHttpResponseClientError,
  isHttpResponseConflict,
  isHttpResponseCreated,
  isHttpResponseForbidden,
  isHttpResponseInternalServerError,
  isHttpResponseMethodNotAllowed,
  isHttpResponseMovedPermanently,
  isHttpResponseNoContent,
  isHttpResponseNotFound,
  isHttpResponseNotImplemented,
  isHttpResponseOK,
  isHttpResponseRedirect,
  isHttpResponseRedirection,
  isHttpResponseServerError,
  isHttpResponseSuccess,
  isHttpResponseTooManyRequests,
  isHttpResponseUnauthorized,
  listRoutes,
  listen,
  load,
  notfound,
  ok,
  permits,
  printRoutes,
  requires,
  routemapToOpenAPI,
  unauthorized
});
