var __create = Object.create;
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getProtoOf = Object.getPrototypeOf;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toESM = (mod, isNodeMode, target) => (target = mod != null ? __create(__getProtoOf(mod)) : {}, __copyProps(isNodeMode || !mod || !mod.__esModule ? __defProp(target, "default", { value: mod, enumerable: true }) : target, mod));
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);

// src/server/load.ts
var load_exports = {};
__export(load_exports, {
  default: () => load_default
});
module.exports = __toCommonJS(load_exports);
var import_path = __toESM(require("path"));
var import_glob = __toESM(require("glob"));
var load = (patt, cwd = process.cwd()) => import_glob.default.sync(import_path.default.join(cwd, patt)).map((f) => {
  let mod = null;
  try {
    mod = require(f);
  } catch (e) {
    console.log(`error dynamically loading '${f}'
${e.toString()}`);
    throw e;
  }
  return mod.default || mod;
});
var load_default = load;
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {});
