var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getOwnPropSymbols = Object.getOwnPropertySymbols;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __propIsEnum = Object.prototype.propertyIsEnumerable;
var __defNormalProp = (obj, key, value) => key in obj ? __defProp(obj, key, { enumerable: true, configurable: true, writable: true, value }) : obj[key] = value;
var __spreadValues = (a, b) => {
  for (var prop in b || (b = {}))
    if (__hasOwnProp.call(b, prop))
      __defNormalProp(a, prop, b[prop]);
  if (__getOwnPropSymbols)
    for (var prop of __getOwnPropSymbols(b)) {
      if (__propIsEnum.call(b, prop))
        __defNormalProp(a, prop, b[prop]);
    }
  return a;
};
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);

// src/server/not-found.ts
var not_found_exports = {};
__export(not_found_exports, {
  default: () => not_found_default
});
module.exports = __toCommonJS(not_found_exports);

// src/http/responses.ts
var HttpResponse = class {
  constructor(body, options = {}) {
    this.body = body;
    this.isHttpResponse = true;
    this.stream = false;
    this.headers = {};
    this.stream = options.stream || false;
  }
  setHeader(name, value) {
    this.headers[name] = value;
    return this;
  }
  getHeader(name) {
    return this.headers[name];
  }
  getHeaders() {
    return __spreadValues({}, this.headers);
  }
};
var HttpResponseClientError = class extends HttpResponse {
  constructor(body, options = {}) {
    super(body, options);
    this.isHttpResponseClientError = true;
  }
};
var HttpResponseNotFound = class extends HttpResponseClientError {
  constructor(body, options = {}) {
    super(body, options);
    this.isHttpResponseNotFound = true;
    this.statusCode = 404;
    this.statusMessage = "NOT FOUND";
  }
};

// src/http/response-sender.ts
var responseSender = (response, result) => {
  response.status(result.statusCode);
  response.set(result.getHeaders());
  if (typeof result.body === "number") {
    result.body = result.body.toString();
  }
  response.send(result.body);
};
var response_sender_default = responseSender;

// src/server/not-found.ts
var notFound = (req, res) => {
  response_sender_default(res, new HttpResponseNotFound());
};
var not_found_default = notFound;
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {});
