import { ZodRawShape, z } from 'zod';

declare const permits: <T extends ZodRawShape>(schema: z.ZodObject<T, "strip", z.ZodTypeAny, z.objectUtil.addQuestionMarks<{ [k_1 in keyof T]: T[k_1]["_output"]; }> extends infer T_1 ? { [k in keyof T_1]: z.objectUtil.addQuestionMarks<{ [k_1 in keyof T]: T[k_1]["_output"]; }>[k]; } : never, z.objectUtil.addQuestionMarks<{ [k_3 in keyof T]: T[k_3]["_input"]; }> extends infer T_2 ? { [k_2 in keyof T_2]: z.objectUtil.addQuestionMarks<{ [k_3 in keyof T]: T[k_3]["_input"]; }>[k_2]; } : never>) => (data: unknown, params?: Partial<z.ParseParams> | undefined) => z.objectUtil.addQuestionMarks<{ [k_1 in keyof T]: T[k_1]["_output"]; }> extends infer T_1 ? { [k in keyof T_1]: z.objectUtil.addQuestionMarks<{ [k_1 in keyof T]: T[k_1]["_output"]; }>[k]; } : never;
declare const requires: <T extends ZodRawShape>(schema: z.ZodObject<T, "strip", z.ZodTypeAny, z.objectUtil.addQuestionMarks<{ [k_1 in keyof T]: T[k_1]["_output"]; }> extends infer T_1 ? { [k in keyof T_1]: z.objectUtil.addQuestionMarks<{ [k_1 in keyof T]: T[k_1]["_output"]; }>[k]; } : never, z.objectUtil.addQuestionMarks<{ [k_3 in keyof T]: T[k_3]["_input"]; }> extends infer T_2 ? { [k_2 in keyof T_2]: z.objectUtil.addQuestionMarks<{ [k_3 in keyof T]: T[k_3]["_input"]; }>[k_2]; } : never>) => (d: any) => z.objectUtil.addQuestionMarks<{ [k_1 in keyof T]: T[k_1]["_output"]; }> extends infer T_1 ? { [k in keyof T_1]: z.objectUtil.addQuestionMarks<{ [k_1 in keyof T]: T[k_1]["_output"]; }>[k]; } : never;
declare function ParseBody(schema: any): MethodDecorator & PropertyDecorator;
declare function ValidateBody(schema: any, customValidations?: {}): MethodDecorator & PropertyDecorator;

export { ParseBody, ValidateBody, permits, requires };
